extends GridMap

const CHUNK_SIZE = 32
var loaded_chunks = []
var needed_chunks = []

func load_chunk(chunk):
	loaded_chunks.push_back(chunk)
	for x in range(chunk.x * CHUNK_SIZE, (chunk.x + 1) * CHUNK_SIZE):
		for z in range(chunk.y * CHUNK_SIZE, (chunk.y + 1) * CHUNK_SIZE):
			set_cell_item(x, 0, z, 0)
	
func unload_chunk(index):
	var chunk = loaded_chunks[index]
	loaded_chunks.remove(index)
	for x in range(chunk.x * CHUNK_SIZE, (chunk.x + 1) * CHUNK_SIZE):
		for z in range(chunk.y * CHUNK_SIZE, (chunk.y + 1) * CHUNK_SIZE):
			set_cell_item(x, 0, z, -1)
			
func is_chunk_loaded(chunk):
	for c in loaded_chunks:
		if c == chunk:
			return true
			
	return false
	
func is_needed_chunk(chunk):
	for c in needed_chunks:
		if c == chunk:
			return true
			
	return false
	
func try_unload_unneeded_chunk():
	for index in range(len(loaded_chunks)):
		if not is_needed_chunk(loaded_chunks[index]):
			unload_chunk(index)
			return true
	return false

func _process(delta):
	var player = get_node("../Player")
	var center = world_to_map(player.translation)
	var chunk = Vector2(int(center.x / CHUNK_SIZE), int(center.z / CHUNK_SIZE) - 1)
	
	needed_chunks.clear()
	for x in range(chunk.x - 2, chunk.x + 2):
		for z in range(chunk.y - 2, chunk.y + 2):
			needed_chunks.push_back(Vector2(x, z))
	
	for c in needed_chunks:
		if not is_chunk_loaded(c):
			load_chunk(c)
			break
			
	while try_unload_unneeded_chunk():
		pass
	
	
		
	